﻿// <auto-generated />
using System;
using EquipmentSystem.DataLayer.Context;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace EquipmentSystem.DataLayer.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("13971206094944_V2019_02_25_1319")]
    partial class V2019_02_25_1319
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.2.1-servicing-10028")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("EquipmentSystem.DomainClasses.Equipment", b =>
                {
                    b.Property<int>("Equip_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Equip_Name")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<int?>("Parent_Equip_ID");

                    b.HasKey("Equip_ID");

                    b.HasIndex("Parent_Equip_ID");

                    b.ToTable("Equipments");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.Office", b =>
                {
                    b.Property<int>("Office_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Office_Code")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("Office_Name")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<int?>("Parent_Office_ID");

                    b.HasKey("Office_ID");

                    b.ToTable("Offices");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.Role", b =>
                {
                    b.Property<int>("Role_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Role_Caption")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("Role_Name")
                        .IsRequired()
                        .HasMaxLength(450);

                    b.HasKey("Role_ID");

                    b.HasIndex("Role_Name")
                        .IsUnique();

                    b.ToTable("Roles");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User", b =>
                {
                    b.Property<int>("User_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool>("IsActive");

                    b.Property<DateTimeOffset?>("LastLoggedIn");

                    b.Property<int>("Office_ID");

                    b.Property<string>("Password")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("SerialNumber")
                        .HasMaxLength(450);

                    b.Property<string>("User_Fname")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("User_Lname")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasMaxLength(450);

                    b.HasKey("User_ID");

                    b.HasIndex("Office_ID");

                    b.HasIndex("Username")
                        .IsUnique();

                    b.ToTable("Users");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.UserRole", b =>
                {
                    b.Property<int>("User_ID");

                    b.Property<int>("Role_ID");

                    b.HasKey("User_ID", "Role_ID");

                    b.HasIndex("Role_ID");

                    b.HasIndex("User_ID");

                    b.ToTable("UserRoles");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.UserToken", b =>
                {
                    b.Property<int>("UserToken_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTimeOffset>("AccessTokenExpiresDateTime");

                    b.Property<string>("AccessTokenHash");

                    b.Property<DateTimeOffset>("RefreshTokenExpiresDateTime");

                    b.Property<string>("RefreshTokenIdHash")
                        .IsRequired()
                        .HasMaxLength(450);

                    b.Property<string>("RefreshTokenIdHashSource")
                        .HasMaxLength(450);

                    b.Property<int>("User_ID");

                    b.HasKey("UserToken_ID");

                    b.HasIndex("User_ID");

                    b.ToTable("UserTokens");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User_Equipment", b =>
                {
                    b.Property<int>("UserEquip_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Desc1")
                        .HasMaxLength(255);

                    b.Property<string>("Desc2")
                        .HasMaxLength(255);

                    b.Property<string>("Desc3")
                        .HasMaxLength(255);

                    b.Property<string>("Desc4")
                        .HasMaxLength(255);

                    b.Property<string>("Desc5")
                        .HasMaxLength(255);

                    b.Property<string>("Desc6")
                        .HasMaxLength(255);

                    b.Property<int>("Equip_ID");

                    b.Property<string>("SHAmval")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("SHSerial")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<int>("User_ID");

                    b.HasKey("UserEquip_ID");

                    b.HasIndex("Equip_ID");

                    b.HasIndex("User_ID");

                    b.ToTable("User_Equipments");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User_EquipmentReq", b =>
                {
                    b.Property<int>("UserEquipReq_ID")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTimeOffset?>("DateDoAction");

                    b.Property<DateTimeOffset?>("DateReqAction");

                    b.Property<string>("Desc1Req")
                        .HasMaxLength(255);

                    b.Property<string>("Desc2Req")
                        .HasMaxLength(255);

                    b.Property<string>("Desc3Req")
                        .HasMaxLength(255);

                    b.Property<string>("Desc4Req")
                        .HasMaxLength(255);

                    b.Property<string>("Desc5Req")
                        .HasMaxLength(255);

                    b.Property<string>("Desc6Req")
                        .HasMaxLength(255);

                    b.Property<int?>("EquipReq_ID");

                    b.Property<string>("SHAmvalReq")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<string>("SHSerialReq")
                        .IsRequired()
                        .HasMaxLength(255);

                    b.Property<int?>("UserDoAction");

                    b.Property<int?>("UserDo_ID");

                    b.Property<int?>("UserRecAction");

                    b.Property<int?>("UserReq_ID");

                    b.HasKey("UserEquipReq_ID");

                    b.HasIndex("EquipReq_ID");

                    b.HasIndex("UserDo_ID");

                    b.HasIndex("UserReq_ID");

                    b.ToTable("User_EquipmentReqs");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.Equipment", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.Equipment", "Parent")
                        .WithMany("Children")
                        .HasForeignKey("Parent_Equip_ID");
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.Office", "Office")
                        .WithMany("Users")
                        .HasForeignKey("Office_ID")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.UserRole", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.Role", "Role")
                        .WithMany("UserRoles")
                        .HasForeignKey("Role_ID")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("EquipmentSystem.DomainClasses.User", "User")
                        .WithMany("UserRoles")
                        .HasForeignKey("User_ID")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.UserToken", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.User", "User")
                        .WithMany("UserTokens")
                        .HasForeignKey("User_ID")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User_Equipment", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.Equipment", "Equipment")
                        .WithMany("User_Equipments")
                        .HasForeignKey("Equip_ID")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("EquipmentSystem.DomainClasses.User", "User")
                        .WithMany("User_Equipments")
                        .HasForeignKey("User_ID")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EquipmentSystem.DomainClasses.User_EquipmentReq", b =>
                {
                    b.HasOne("EquipmentSystem.DomainClasses.Equipment", "EquipmentReq")
                        .WithMany()
                        .HasForeignKey("EquipReq_ID");

                    b.HasOne("EquipmentSystem.DomainClasses.User", "UserDo")
                        .WithMany("Do_User_EquipmentReqs")
                        .HasForeignKey("UserDo_ID")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("EquipmentSystem.DomainClasses.User", "UserReq")
                        .WithMany("Req_User_EquipmentReqs")
                        .HasForeignKey("UserReq_ID")
                        .OnDelete(DeleteBehavior.Restrict);
                });
#pragma warning restore 612, 618
        }
    }
}
